# Woods1D K&S, R.Sluiter 07/06/99
# Original point.mod (woods) D.J. Karssenberg


binding
 TimeStep=scalar(1);             # number of years represented by one timestep
 ReplSpaSpb=scalar($ReplaceA);       # replacement coeff Spa->Spb
 ReplSpbSpa=scalar($ReplaceB);         # replacement coeff Spb->Spa
 SpaIniCover=scalar($IcoverA);          # initial cover Spa
 SpbIniCover=scalar($IcoverB);        # initial cover Spb
 SpaRateYear=scalar($GrateA);       # growth rates for Spa 
 SpbRateYear=scalar($GrateB);     # growth rates for Spb 
 MaxCover=scalar(100);            # maximum cover
 AnimalDamageYear=scalar(0.00);          # animal damage (percent cover), try 0.03
 Percentageseries=$Perc;
 Growthseries=$Growth;
 Prctottss=$Prctot;
 Type=Mask.map;
 Points=Points.map;

areamap
 Mask.map;

timer
 1 200 1;

initial
 AnimalDamage=AnimalDamageYear*TimeStep;
 Spa=SpaIniCover;
 Spb=SpbIniCover;
 Tot=Spa+Spb;
 RateSpa=SpaRateYear*TimeStep;
 RateSpb=SpbRateYear*TimeStep;

dynamic
 # growth Spa per timestep 
 GrowthSpa=RateSpa*Spa*(MaxCover-Spa-ReplSpaSpb*Spb)/MaxCover-AnimalDamage;

 # growth Spb per timestep
 GrowthSpb=RateSpb*Spb*(MaxCover-Spb-ReplSpbSpa*Spa)/MaxCover-AnimalDamage;

 # percent Spa
 Spa=min(max(Spa+GrowthSpa,0),MaxCover-Spb);
 # percent Spb
 Spb=min(max(Spb+GrowthSpb,0),MaxCover-Spa);
 # total percent
 Tot=min (Spa+Spb,MaxCover);

 # timeseries with percent Spa and Spb
 #prcSpa.tss=mapmaximum(Spa);
 #prcSpb.tss=mapmaximum(Spb);

 # timeseries with total percent
 report Prctottss=timeoutput(Points,Tot);

 # factor of trees that is Spb
 #pfSpb.tss=Spb/Tot;
 
 # Reporting
 Plantcover=if(Type eq 1,Spa,Spb);
 Growthcover=if(Type eq 1,GrowthSpa,GrowthSpb);
 report Percentageseries=timeoutput(Points,Plantcover);
 report Growthseries=timeoutput(Points,Growthcover);